#ifndef _MACHINE_
#define _MACHINE_

/* some trivial macros for dealing with
** old K&R C compilers vs. ANSI C,
** __STDC__ is a built-in macro in ANSI C Compilers.
** (c) Ian Cottam, University of Manchester.
*/
#if __STDC__
#define ARGS(parameters) parameters
#define C(parameter) parameter
#define PreANSI(parameters) % nothing %
#else
#define ARGS(parameters) ()
#define C(parameter) /* nothing */
#define PreANSI(parameters) parameters;
#endif 

#ifdef VMS 

/* Equate SunPHIGS Specific names to DEC PHIGS names*/

#define Ppoint4 PPpoint4 

#define PELEM_LOCAL_MODEL_TRAN3 PEL_LOCAL_MODELLING_TRANSFORM3

#define PELEM_LOCAL_MODEL_TRAN PEL_LOCAL_MODELLING_TRANSFORM

#define PELEM_GLOBAL_MODEL_TRAN3 PEL_GLOBAL_MODELLING_TRANSFORM3

#define PELEM_GLOBAL_MODEL_TRAN PEL_GLOBAL_MODELLING_TRANSFORM

#define PELEM_ANNO_CHAR_HT PEL_ANNOTATION_TEXT_CHARACTER_H

#define PELEM_ANNO_CHAR_UP_VEC PEL_ANNOTATION_TEXT_CHARACTER_U

#define PELEM_PAT_REF_POINT_VECS PEL_PAT_REF_POINT_AND

#define PELEM_MODEL_CLIP_VOL3 200

#define PELEM_MODEL_CLIP_IND PEL_MODELLING_CLIPPING_INDICATO

#define PELEM_RESTORE_MODEL_CLIP_VOL PEL_RESTORE_MODELLING_CLIPPING_

/*
 Not required for DEC PHIGS 2.3A  
#define PHOR_NORM PTH_NORMAL
#define PHOR_LEFT   PTH_LEFT
#define PHOR_CTR PTH_CENTRE
#define PHOR_RIGHT  PTH_RIGHT
*/

#define PASPECT_MARKER_SIZE PMARKERWIDTH_SCALE_FACTOR

#define PHATCH_HORIZ -4

#define PANNO_STYLE_UNCONNECTED PAS_UNCONNECTED

#define Pconf_res Pconflictres

#define Pin_class Pin_class

#define par_all_structs parchiveallstruct

#define par_structs parchivestruct

#define par_struct_nets parchivestructnet

#define pclose_ar_file pclosearchivefile

#define pdel_all_structs_ar pdelallstructarchive

#define pdel_structs_ar pdelstructarchive

#define pdel_struct_nets_ar pdelstructnetarchive

#define popen_ar_file popenarchivefile

#define pinq_paths_ances pinqancestorsstruct

#define pinq_ar_files pinqarchivefiles

#define pinq_ar_st pinqarchivest

#define pinq_all_conf_structs pinqallconflictstruct

#define pinq_conf_res pinqconflictres

#define pinq_conf_structs_net pinqconflictstructinnet

#define pinq_paths_descs pinqdecendentsstruct

#define pinq_num_disp_pris pinqnumstructpri

#define pset_conf_res psetconflictres

#define pinq_highl_filter pinqhighlightfilter

#define pset_highl_filter psethighlightfilter

#define pret_struct_ids pretrievearchivedstructids

#endif

/* where HP fails to meet ISO PHIGS C */

#ifdef HP

#define size_asf width_asf

#endif

/* where SUN fails to meet ISO PHIGS C */

#ifdef SUN

#define in_buf_size buffer_size

#endif

/* where PEX-SI fails to meet ISO PHIGS C */

#ifdef PEXSI

#define in_buf_size buffer_size

#endif

#endif




