#ifndef _TRANTYPE_
#define _TRANTYPE_

#define ptkcpceps           1.0e-7

#define ptkcpcok            0

typedef enum
{
  PTKEXAXIS = 1,
  PTKEYAXIS,
  PTKEZAXIS
} ptkeaxistype;


#ifdef SUN
#ifdef PHIGS_H_INCLUDED
#define PHIGS_INCLUDE
#endif
#endif

#ifdef PEXSI
#ifdef PHIGS_H_INCLUDED
#define PHIGS_INCLUDE
#endif
#endif

#ifdef VMS
#ifdef PHIGS_H
#define PHIGS_INCLUDE
#endif
#endif

#ifdef HP
#ifdef PMODEL_RGB
#define PHIGS_INCLUDE
#endif
#endif

#ifndef PHIGS_INCLUDE

typedef float Pfloat;

#ifdef __TURBOC__
typedef long   Pint;
#else
typedef int   Pint;
#endif

typedef long Plong;

typedef Pfloat Pmatrix[3][3];
typedef Pfloat Pmatrix3[4][4];

/* Enumerated types */

typedef enum
{
 PTYPE_PARAL,
 PTYPE_PERSPECT
} Pproj_type;

typedef enum
{
 PTYPE_PRECONCAT,
 PTYPE_POSTCONCAT,
 PTYPE_REPLACE
} Pcompose_type;

typedef struct
{
  Pfloat delta_x;
  Pfloat delta_y;
} Pvec;

typedef struct
{
  Pfloat delta_x;
  Pfloat delta_y;
  Pfloat delta_z;
} Pvec3;

typedef struct
{
  Pfloat x;
  Pfloat y;
} Ppoint;

typedef struct
{
  Pfloat x;
  Pfloat y;
  Pfloat z;
} Ppoint3;

typedef struct
{
  Pfloat x_min;
  Pfloat x_max;
  Pfloat y_min;
  Pfloat y_max;
} Plimit;

typedef struct
{
  Pfloat x_min;
  Pfloat x_max;
  Pfloat y_min;
  Pfloat y_max;
  Pfloat z_min;
  Pfloat z_max;
} Plimit3;

#ifndef HP
typedef struct 
{
  Pfloat x;
  Pfloat y;
  Pfloat z;
  Pfloat w;
#ifdef SUN
} Ppoint4;
#endif
#ifdef PEXSI
} Ppoint4;
#endif
#ifdef VMS
} PPpoint4;
#endif
#endif

#endif

extern Pfloat ptkveps;

#ifdef HP
typedef struct 
{
  Pfloat x;
  Pfloat y;
  Pfloat z;
  Pfloat w;
} Ppoint4;
#endif

#endif

/* End. */
