/*--------------------------------------------------------------------------*/
/*---------------------- phinter set functions -----------------------------*/
/*--------------------------------------------------------------------------*/

static void do_psetannotationalign()
{
  Ptext_align a;

  a.hor = readphigsenum(PTKETXHOR, "horizontal alignment ? ");
  a.vert = readphigsenum(PTKETXVER, "vertical alignment ? ");
  pset_anno_align(&a);
}  /* do_psetannotationalign */

/*--------------------------------------------------------------------------*/

static void do_psetannotationcharheight()
{
  pset_anno_char_ht(readreal("annotation character height  ? "));
}  /* do_psetannotationcharheight */

/*--------------------------------------------------------------------------*/

static void do_psetannotationcharup()
{
  Pvec v;

  v = readvector("annotation character up vector");
  pset_anno_char_up_vec(&v);
}  /* do_psetannotationcharup */

/*--------------------------------------------------------------------------*/

static void do_psetannotationpath()
{
  Ptext_path p;

  p = readphigsenum(PTKETXPATH, "annotation text path ? ");
  pset_anno_path(p);
}  /* do_psetannotationpath */

/*--------------------------------------------------------------------------*/

static void do_psetannotationstyle()
{
  pset_anno_style(readinteger("annotation style ? "));
}  /* do_psetannotationstyle */

/*--------------------------------------------------------------------------*/

static void do_psetcharexpan()
{
  pset_char_expan(readreal("character expansion ? "));
}  /* do_psetcharexpan */

/*--------------------------------------------------------------------------*/

static void do_psetcharheight()
{
  pset_char_ht(readreal("character height ? "));
}  /* do_psetcharheight */

/*--------------------------------------------------------------------------*/

static void do_psetcharspace()
{
  pset_char_space(readreal("character spacing ? "));
}  /* do_psetcharspace */

/*--------------------------------------------------------------------------*/

static void do_psetcharup()
{
  Pvec v;

  v = readvector("character up vector");
  pset_char_up_vec(&v);
}  /* do_psetcharup */

/*--------------------------------------------------------------------------*/

static void do_psetchoicemode()
{
  Pint wsid, dev;
  Pop_mode mode;
  Pecho_switch echo;

  wsid = readinteger("workstation identifier ? ");
  dev = readinteger("choice device number ? ");
  mode = readphigsenum(PTKEIMODE, "operating mode ? ");
  echo = readphigsenum(PTKEESW, "echo switch ? ");
  pset_choice_mode(wsid, dev, mode, echo);
}  /* do_psetchoicemode */

/*--------------------------------------------------------------------------*/

static void do_psetcolourmodel()
{
  Pint wsid, model;

  wsid = readinteger("workstation identifier ? ");
  model = readinteger("colour model ? ");
  pset_colr_model(wsid, model);
}  /* do_psetcolourmodel */

/*--------------------------------------------------------------------------*/

static void do_psetcolourrep()
{
  Pint w, i;
  Pcolr_rep c;

  w = readinteger("workstation identifier ? ");
  i = readposintvalue("colour table index ? ", PTKECOLOURIND);
  getcolourmodel(w);
  c = readcolour();
  pset_colr_rep(w, i, c);
}  /* do_psetcolourrep */

/*--------------------------------------------------------------------------*/

static void do_psetconfres()
{
  pset_conf_res(readphigsenum(PTKECONFRES, "archive conflict ? "), readphigsenum(PTKECONFRES, "retrieve conflict ? "));
}  /* do_psetconfres */

/*--------------------------------------------------------------------------*/

static void do_psetdisplayupdatest()
{
  Pint wsid;
  Pdefer_mode defer;
  Pmod_mode modmode;

  wsid = readinteger("workstation identifier ? ");
  defer = readphigsenum(PTKEDEFMODE, "deferral mode ? ");
  modmode = readphigsenum(PTKEMOD, "modification mode ? ");
  pset_disp_upd_st(wsid, defer, modmode);
}  /* do_psetdisplayupdatest */

/*--------------------------------------------------------------------------*/

static void do_psetedgecolourind()
{
  pset_edge_colr_ind(readposintvalue("edge colour index ? ", PTKECOLOURIND));
}  /* do_psetedgecolourind */

/*--------------------------------------------------------------------------*/

static void do_psetedgeflag()
{
  Pedge_flag edgeflag;

  edgeflag = readphigsenum(PTKEEDGEF, "edge flag ? ");
  pset_edge_flag(edgeflag);
}  /* do_psetedgeflag */

/*--------------------------------------------------------------------------*/

static void do_psetedgeind()
{
  pset_edge_ind(readposinteger("edge index ? "));
}  /* do_psetedgeind */

/*--------------------------------------------------------------------------*/

static void do_psetedgerep()
{
  Pint wsid, index;
  Pedge_bundle rep;

  wsid = readinteger("workstation identifier ? ");
  index = readposinteger("edge bundle index ? ");
  readedgebundl(&rep);
  pset_edge_rep(wsid, index, &rep);
}  /* do_psetedgerep */

/*--------------------------------------------------------------------------*/

static void do_psetedgewidth()
{
  pset_edgewidth(readreal("edge width ? "));
}  /* do_psetedgewidth */

/*--------------------------------------------------------------------------*/

static void do_psetedgetype()
{
  pset_edgetype(readinteger("edge type ? "));
}  /* do_psetedgetype */

/*--------------------------------------------------------------------------*/

static void do_pseteditmode()
{
  Pedit_mode mode;

  mode = readphigsenum(PTKEEDITMODE, "edit mode ? ");
  pset_edit_mode(mode);
}  /* do_pseteditmode */

/*--------------------------------------------------------------------------*/

static void do_psetelemptr()
{
  pset_elem_ptr(readinteger("element pointer ? "));
}  /* do_psetelemptr */

/*--------------------------------------------------------------------------*/

static void do_psetelemptrlabel()
{
  pset_elem_ptr_label(readintvalue("label ? ", PTKELABELVAL));
}  /* do_psetelemptrlabel */

/*--------------------------------------------------------------------------*/

static void do_pseterrorhandmode()
{
  Perr_mode mode;

  mode = readphigsenum(PTKEERRORMODE, "error handling mode ? ");
  pset_err_hand_mode(mode);
}  /* do_pseterrorhandmode */

/*--------------------------------------------------------------------------*/

static void do_psetglobaltran()
{
  Pmatrix xform;

  readmatrix(xform, "global transformation matrix");
  pset_global_tran(xform);
}  /* do_psetglobaltran */

/*--------------------------------------------------------------------------*/

static void do_psetglobaltran3()
{
  Pmatrix3 m;

  readmatrix3(m, "global transformation matrix");
  pset_global_tran3(m);
}  /* do_psetglobaltran3 */

/*--------------------------------------------------------------------------*/

static void do_psethlhsrid()
{
  pset_hlhsr_id(readinteger("HLHSR identifier ? "));
}  /* do_psethlhsrid */

/*--------------------------------------------------------------------------*/

static void do_psethlhsrmode()
{
  Pint wsid, mode;

  wsid = readinteger("workstation identifier ? ");
  mode = readinteger("HLHSR mode ? ");
  pset_hlhsr_mode(wsid, mode);
}  /* do_psethlhsrmode */

/*--------------------------------------------------------------------------*/

static void do_psethilightfilter()
{
  Pint wsid;
  Pfilter highfilt;

  wsid = readinteger("workstation identifier ? ");
  readintlst(&highfilt.incl_set, "inclusion set", PTKENAME);
  readintlst(&highfilt.excl_set, "exclusion set", PTKENAME);
  pset_highl_filter(wsid, &highfilt);
  free(highfilt.incl_set.ints);
  free(highfilt.excl_set.ints);
}  /* do_psethilightfilter */

/*--------------------------------------------------------------------------*/

static void do_psetindivasf()
{
  Paspect attid;
  Pasf attsource;

  attid = readphigsenum(PTKEATTRID, "attribute identifier ? ");
  attsource = readphigsenum(PTKEASF, "attribute source ? ");
  pset_indiv_asf(attid, attsource);
}  /* do_psetindivasf */

/*--------------------------------------------------------------------------*/

static void do_psetintcolourind()
{
  pset_int_colr_ind(readposintvalue("interior colour index ? ", PTKECOLOURIND));
}  /* do_psetintcolourind */

/*--------------------------------------------------------------------------*/

static void do_psetintind()
{
  pset_int_ind(readposinteger("interior index ? "));
}  /* do_psetintind */

/*---------------------------------------------------------------------------*/

static void do_psetintrep()
{
  Pint wsid, index;
  Pint_bundle rep;

  wsid = readinteger("workstation identifier ? ");
  index = readposinteger("interior bundle index ? ");
  readinterbundl(&rep);
  pset_int_rep(wsid, index, &rep);
}  /* do_psetintrep */

/*--------------------------------------------------------------------------*/

static void do_psetintstyle()
{
  Pint_style style;

  style = readphigsenum(PTKEINTERSTYLE, "interior style ? ");
  pset_int_style(style);
}  /* do_psetintstyle */

/*--------------------------------------------------------------------------*/

static void do_psetintstyleind()
{
  pset_int_style_ind(readinteger("interior style index ? "));
}  /* do_psetintstyleind */

/*--------------------------------------------------------------------------*/

static void do_psetinvisfilter()
{
  Pint wsid;
  Pfilter invisfilt;

  wsid = readinteger("workstation identifier ? ");
  readintlst(&invisfilt.incl_set, "inclusion set", PTKENAME);
  readintlst(&invisfilt.excl_set, "exclusion set", PTKENAME);
  pset_invis_filter(wsid, &invisfilt);
  free(invisfilt.incl_set.ints);
  free(invisfilt.excl_set.ints);
}  /* do_psetinvisfilter */

/*--------------------------------------------------------------------------*/

static void do_psetlinecolourind()
{
  pset_line_colr_ind(readposintvalue("line colour index ? ", PTKECOLOURIND));
}  /* do_psetlinecolourind */

/*--------------------------------------------------------------------------*/

static void do_psetlinewidth()
{
  pset_linewidth(readreal("line width ? "));
}  /* do_psetlinewidth */

/*--------------------------------------------------------------------------*/

static void do_psetlinetype()
{
  pset_linetype(readinteger("line type ? "));
}  /* do_psetlinetype */

/*--------------------------------------------------------------------------*/

static void do_psetlocaltran()
{
  Pmatrix m;
  Pcompose_type c;

  readmatrix(m, "matrix elements");
  c = readphigsenum(PTKECOMPTYPE, "composition type ? ");
  pset_local_tran(m, c);
}  /* do_psetlocaltran */

/*--------------------------------------------------------------------------*/

static void do_psetlocaltran3()
{
  Pmatrix3 m;
  Pcompose_type c;

  readmatrix3(m, "matrix elements");
  c = readphigsenum(PTKECOMPTYPE, "composition type ? ");
  pset_local_tran3(m, c);
}  /* do_psetlocaltran3 */

/*--------------------------------------------------------------------------*/

static void do_psetlocmode()
{
  Pint wsid, dev;
  Pop_mode mode;
  Pecho_switch echo;

  wsid = readinteger("workstation identifier ? ");
  dev = readinteger("locator device number ? ");
  mode = readphigsenum(PTKEIMODE, "operating mode ? ");
  echo = readphigsenum(PTKEESW, "echo switch ? ");
  pset_loc_mode(wsid, dev, mode, echo);
}  /* do_psetlocmode */

/*--------------------------------------------------------------------------*/

static void do_psetmarkercolourind()
{
  pset_marker_colr_ind(readposintvalue("marker colour index ? ", PTKECOLOURIND));
}  /* do_psetmarkercolourind */

/*--------------------------------------------------------------------------*/

static void do_psetmarkersize()
{
  pset_marker_size(readreal("marker size ? "));
}  /* do_psetmarkersize */

/*--------------------------------------------------------------------------*/

static void do_psetmarkertype()
{
  pset_marker_type(readinteger("marker type ? "));
}  /* do_psetmarkertype */

/*--------------------------------------------------------------------------*/

static void do_psetmodelclipindicator()
{
  Pclip_ind ind;

  ind = readphigsenum(PTKECLIP, "clipping indicator ? ");
  pset_model_clip_ind(ind);
}  /* do_psetmodelclipindicator */

/*--------------------------------------------------------------------------*/

static void do_psetmodelclipvolume()
{
  Pint op, i;
  Phalf_space_list halfspaces;

  op = readinteger("operator ? ");
  halfspaces.num_half_spaces = readinteger("number of half spaces ? ");
  halfspaces.half_spaces = (Phalf_space *)calloc(halfspaces.num_half_spaces, 
                           sizeof(Phalf_space));
  for (i = 0; i < halfspaces.num_half_spaces; i++)
  {
    halfspaces.half_spaces[i].point = readpoint("half space point");
    halfspaces.half_spaces[i].norm = readvector("half space normal");
  }
  pset_model_clip_vol(op, &halfspaces);
}  /* do_psetmodelclipvolume */

/*--------------------------------------------------------------------------*/

static void do_psetmodelclipvolume3()
{
  Pint op, i;
  Phalf_space_list3 halfspaces;

  op = readinteger("operator ? ");
  halfspaces.num_half_spaces = readinteger("number of half spaces ? ");
  halfspaces.half_spaces = (Phalf_space3 *)calloc(halfspaces.num_half_spaces, 
                           sizeof(Phalf_space3));
  for (i = 0; i < halfspaces.num_half_spaces; i++)
  {
    halfspaces.half_spaces[i].point = readpoint3("half space point");
    halfspaces.half_spaces[i].norm = readvector3("half space normal");
  }
  pset_model_clip_vol3(op, &halfspaces);
}  /* do_psetmodelclipvolume3 */

/*--------------------------------------------------------------------------*/

static void do_psetpatrefpt()
{
  Ppoint refpt;

#ifdef HP
  phintererror(1, (char *)NULL, INFORM);
#else
  refpt = readpoint("pattern reference point");
  pset_pat_ref_point(&refpt);
#endif
}  /* do_psetpatrefpt */

/*--------------------------------------------------------------------------*/

static void do_psetpatrefptvectors()
{
  Ppoint3 refpt;
  Pvec3 dx, dy;

#ifdef HP
  phintererror(1, (char *)NULL, INFORM);
#else
  refpt = readpoint3("pattern reference point");
  dx = readvector3("pattern x axis");
  dy = readvector3("pattern y axis");
#endif
}  /* do_psetpatrefptvectors */

/*--------------------------------------------------------------------------*/

static void do_psetpatrep()
{
  phintererror(1, (char *)NULL, INFORM);
}  /* do_psetpatrep */

/*--------------------------------------------------------------------------*/

static void do_psetpatsize()
{
  Pfloat patsizex, patsizey;

#ifdef HP
  phintererror(1, (char *)NULL, INFORM);
#else
  patsizex = readreal("pattern size x");
  patsizey = readreal("pattern size y");
  pset_pat_size(patsizex, patsizey);
#endif
}  /* do_psetpatsize */

/*--------------------------------------------------------------------------*/

static void do_psetpickfilter()
{
  Pint wsid, dev;
  Pfilter pickfilt;

  wsid = readinteger("workstation identifier ? ");
  dev = readinteger("pick device number ? ");
  readintlst(&pickfilt.incl_set, "inclusion set", PTKENAME);
  readintlst(&pickfilt.excl_set, "exclusion set", PTKENAME);
  pset_pick_filter(wsid, dev, &pickfilt);
  free(pickfilt.incl_set.ints);
  free(pickfilt.excl_set.ints);
}  /* do_psetpickfilter */

/*--------------------------------------------------------------------------*/

static void do_psetpickid()
{
  pset_pick_id(readinteger("pick identifier ? "));
}  /* do_psetpickid */

/*--------------------------------------------------------------------------*/

static void do_psetpickmode()
{
  Pint wsid, dev;
  Pop_mode mode;
  Pecho_switch echo;

  wsid = readinteger("workstation identifier ? ");
  dev = readinteger("pick device number ? ");
  mode = readphigsenum(PTKEIMODE, "operating mode ? ");
  echo = readphigsenum(PTKEESW, "echo switch ? ");
  pset_pick_mode(wsid, dev, mode, echo);
}  /* do_psetpickmode */

/*--------------------------------------------------------------------------*/

static void do_psetlineind()
{
  pset_line_ind(readposinteger("polyline index ? "));
}  /* do_psetlineind */

/*--------------------------------------------------------------------------*/

static void do_psetlinerep()
{
  Pint wsid, index;
  Pline_bundle rep;

  wsid = readinteger("workstation identifier ? ");
  index = readposinteger("line bundle index ? ");
  readlnbundl(&rep);
  pset_line_rep(wsid, index, &rep);
}  /* do_psetlinerep */

/*--------------------------------------------------------------------------*/

static void do_psetmarkerind()
{
  pset_marker_ind(readposinteger("polymarker index ? "));
}  /* do_psetmarkerind */

/*--------------------------------------------------------------------------*/

static void do_psetmarkerrep()
{
  Pint wsid, index;
  Pmarker_bundle rep;

  wsid = readinteger("workstation identifier ? ");
  index = readposinteger("marker bundle index ? ");
  readmkbundl(&rep);
  pset_marker_rep(wsid, index, &rep);
}  /* do_psetmarkerrep */

/*--------------------------------------------------------------------------*/

static void do_psetstringmode()
{
  Pint wsid, dev;
  Pop_mode mode;
  Pecho_switch echo;

  wsid = readinteger("workstation identifier ? ");
  dev = readinteger("string device number ? ");
  mode = readphigsenum(PTKEIMODE, "operating mode ? ");
  echo = readphigsenum(PTKEESW, "echo switch ? ");
  pset_string_mode(wsid, dev, mode, echo);
}  /* do_psetstringmode */

/*--------------------------------------------------------------------------*/

static void do_psetstrokemode()
{
  Pint wsid, dev;
  Pop_mode mode;
  Pecho_switch echo;

  wsid = readinteger("workstation identifier ? ");
  dev = readinteger("stroke device number ? ");
  mode = readphigsenum(PTKEIMODE, "operating mode ? ");
  echo = readphigsenum(PTKEESW, "echo switch ? ");
  pset_stroke_mode(wsid, dev, mode, echo);
}  /* do_psetstrokemode */

/*--------------------------------------------------------------------------*/

static void do_psettextalign()
{
  Ptext_align a;

  a.hor = readphigsenum(PTKETXHOR, "horizontal alignment ? ");
  a.vert = readphigsenum(PTKETXVER, "vertical alignment ? ");
  pset_text_align(&a);
}  /* do_psetextalign */

/*--------------------------------------------------------------------------*/

static void do_psettextcolourind()
{
  pset_text_colr_ind(readposintvalue("text colour index ? ", PTKECOLOURIND));
}  /* do_psettextcolourind */

/*--------------------------------------------------------------------------*/

static void do_psettextfont()
{
  pset_text_font(readinteger("text font ? "));
}  /* do_psettextfont */

/*--------------------------------------------------------------------------*/

static void do_psettextind()
{
  pset_text_ind(readposinteger("text index ? "));
}  /* do_psettextind */

/*--------------------------------------------------------------------------*/

static void do_psettextpath()
{
  Ptext_path p;

  p = readphigsenum(PTKETXPATH, "text path ? ");
  pset_text_path(p);
}  /* do_psettextpath */

/*--------------------------------------------------------------------------*/

static void do_psettextprec()
{
  Ptext_prec txprec;

  txprec = readphigsenum(PTKETXPREC, "text precision ? ");
  pset_text_prec(txprec);
}  /* do_psettextprec */

/*--------------------------------------------------------------------------*/

static void do_psettextrep()
{
  Pint wsid, index;
  Ptext_bundle rep;

  wsid = readinteger("workstation identifier ? ");
  index = readposinteger("text bundle index ? ");
  readtxbundl(&rep);
  pset_text_rep(wsid, index, &rep);
}  /* do_psettextrep */

/*--------------------------------------------------------------------------*/

static void do_psetvalmode()
{
  Pint wsid, dev;
  Pop_mode mode;
  Pecho_switch echo;

  wsid = readinteger("workstation identifier ? ");
  dev = readinteger("valuator device number ? ");
  mode = readphigsenum(PTKEIMODE, "operating mode ? ");
  echo = readphigsenum(PTKEESW, "echo switch ? ");
  pset_val_mode(wsid, dev, mode, echo);
}  /* do_psetvalmode */

/*--------------------------------------------------------------------------*/

static void do_psetviewind()
{
  Pint i;

  i = readposintvalue("view index? ", PTKEVIEWIND);
  pset_view_ind(i);
}  /* do_psetviewind */

/*--------------------------------------------------------------------------*/

static void do_psetviewrep()
{
  Pint wsid, index;
  Pview_rep rep;

  wsid = readinteger("workstation identifier ? ");
  index = readposintvalue("view index ? ", PTKEVIEWIND);
  readmatrix(rep.ori_matrix, "orientation matrix");
  readmatrix(rep.map_matrix, "mapping matrix");
  rep.clip_limit = readlimit("clipping limits");
  rep.xy_clip = readphigsenum(PTKECLIP, "x-y clipping indicator ? ");
  pset_view_rep(wsid, index, &rep);
}  /* do_psetviewrep */

/*--------------------------------------------------------------------------*/

static void do_psetviewrep3()
{
  Pint wsid, index;
  Pview_rep3 rep;

  wsid = readinteger("workstation identifier ? ");
  index = readposinteger("view index ? ");
  readmatrix3(rep.ori_matrix, "orientation matrix");
  readmatrix3(rep.map_matrix, "mapping matrix");
  rep.clip_limit = readlimit3("clipping limits");
  rep.xy_clip = readphigsenum(PTKECLIP, "x-y clipping indicator ? ");
  rep.back_clip = readphigsenum(PTKECLIP, "back clipping indicator ? ");
  rep.front_clip = readphigsenum(PTKECLIP, "front clipping indicator ? ");
  pset_view_rep3(wsid, index, &rep);
}  /* do_psetviewrep3 */

/*--------------------------------------------------------------------------*/

static void do_psetviewtraninputpri()
{
  Pint wsid, index, refindex;
  Prel_pri priority;

  wsid = readinteger("workstation identifier ? ");
  index = readposinteger("view index ? ");
  refindex = readposinteger("reference view index ? ");
  priority = readphigsenum(PTKEVPRI, "relative priority ? ");
  pset_view_tran_in_pri(wsid, index, refindex, priority);
}  /* do_psetviewtraninputpri */

/*--------------------------------------------------------------------------*/

static void do_psetwsviewport()
{
  Pint wsid;
  Plimit viewport;

  wsid = readinteger("workstation identifier ? ");
  viewport = readlimit("viewport limits");
  pset_ws_vp(wsid, &viewport);
}  /* do_psetwsviewport */

/*--------------------------------------------------------------------------*/

static void do_psetwsviewport3()
{
  Pint wsid;
  Plimit3 viewport;

  wsid = readinteger("workstation identifier ? ");
  viewport = readlimit3("viewport limits");
  pset_ws_vp3(wsid, &viewport);
}  /* do_psetwsviewport3 */

/*--------------------------------------------------------------------------*/

static void do_psetwswindow()
{
  Pint wsid;
  Plimit window;

  wsid = readinteger("workstation identifier ? ");
  window = readlimit("window limits");
  pset_ws_win(wsid, &window);
}  /* do_psetwswindow */

/*--------------------------------------------------------------------------*/

static void do_psetwswindow3()
{
  Pint wsid;
  Plimit3 window;

  wsid = readinteger("workstation identifier ? ");
  window = readlimit3("window limits");
  pset_ws_win3(wsid, &window);
}  /* do_psetwswindow3 */

/*--------------------------------------------------------------------------*/

/* end of psetfns.c */
